
extern int PasswordDialog (HWND hDlg, int Msg, int wParam, int lParam)
{
	static HWND SystemMenu;
	static HWND PasswordBitStatus;
	static HWND EffeciencyBits_hWnd;

	static float PasswordLen = 0;
	static float PasswordBits = 0;
	static float EffeciencyBits = 0;

	static char LocalTemp[257];

	for(;;)
	{
		if(Msg==WM_INITDIALOG)
		{
			PasswordDialog_hWnd=hDlg;

			SystemMenu = GetSystemMenu(PasswordDialog_hWnd,FALSE);
			AppendMenu(SystemMenu,MF_SEPARATOR,0,0);
			AppendMenu(SystemMenu,MF_STRING,VersionInfo,"Version");

			SendMessage(PasswordDialog_hWnd, WM_SETICON, TRUE,(LPARAM)LoadIcon(GetWindowInstance(PasswordDialog_hWnd), MAKEINTRESOURCE(100)));
			SendMessage(PasswordDialog_hWnd, WM_SETTEXT, FALSE,(LPARAM)TitleCaption);

			CenterWindow(PasswordDialog_hWnd);

			PasswordBitStatus = GetDlgItem(PasswordDialog_hWnd,1000);
			EffeciencyBits_hWnd = GetDlgItem(PasswordDialog_hWnd,2000);

			InfoTextStatic_hWnd = GetDlgItem(PasswordDialog_hWnd,101);
			PasswordEdit_hWnd = GetDlgItem(PasswordDialog_hWnd,102);

			if(Encrypt || !Decrypt)
				SetText(InfoTextStatic_hWnd,"Enter A Password To Be Used To Encrypt This Data");

			if(Decrypt || !Encrypt)
				SetText(InfoTextStatic_hWnd,"Enter The Password That Was Used To Encrypt This Data.");

			if(Encrypt)
			{
				EnableWindow(PasswordBitStatus,TRUE);
				EnableWindow(EffeciencyBits_hWnd,TRUE);
				EnableWindow(GetDlgItem(PasswordDialog_hWnd,1500),TRUE);
			}


			break;
		}
		//----------------------------------------------------------------------

		if(Msg == 307) // Key Down
		{
			PasswordLen = strlen(GetText(PasswordEdit_hWnd));

			if(PasswordLen >= 4)EnableWindow(GetDlgItem(PasswordDialog_hWnd,103),TRUE);
			if(PasswordLen <  4)EnableWindow(GetDlgItem(PasswordDialog_hWnd,103),FALSE);

			if(Encrypt)
			{
				PasswordBits = (PasswordLen * 8); /* 8-Bits Per Character*/
				EffeciencyBits = (PasswordLen / 70) * 100;

				SendMessage(PasswordBitStatus, PBM_SETPOS,EffeciencyBits,0);

				sprintf(LocalTemp,"(%.0f Bits)",PasswordBits);
				SetText(EffeciencyBits_hWnd,LocalTemp);
			}
		}

		if(Msg==WM_COMMAND)
		{
			if(wParam==103)
			{

				CodedKey = CipherKey(GetText(PasswordEdit_hWnd));


				if(!PackingFiles)Thread_Handle = CreateThread(NULL,0,Thread,(LPVOID)0,0,&Thread_ID);

				if(Encrypt || !Decrypt) //Encrypt
				{
					EndDialog(PasswordDialog_hWnd,0);
					EncryptProcess();
				}

				if(Decrypt || !Encrypt) //Decrypt
				{
					EndDialog(PasswordDialog_hWnd,0);
					DecryptProcess();
				}

				CleanUp(0,1);

				Encrypt = 0;
				Decrypt = 0;

				while(!Verifiy)
				{
					if(!DoneFlag)DoneFlag = 1;
				}
			}

			if(wParam == 104) //Close Dialog
			{
				if(PackingFiles)unlink(F);
				CleanUp(0,1);
				EndDialog(PasswordDialog_hWnd,0);
			}

			if(wParam==106) //Open About Dialog
			{
				ShowWindow(PasswordDialog_hWnd,FALSE);
				DialogBox(hInstance,MAKEINTRESOURCE(1000),PasswordDialog_hWnd,AboutDialog);
				ShowWindow(PasswordDialog_hWnd,TRUE);
			}
			break;
		}

		if(Msg == WM_SYSCOMMAND)
		{
			if(LOWORD(wParam) == VersionInfo)
			{
				MessageBox(PasswordDialog_hWnd,Version ,TitleCaption, 0 + MB_ICONASTERISK + MB_TASKMODAL);
			}
		}

		if(Msg == WM_CLOSE) //Close Dialog
		{
			if(PackingFiles)unlink(F);
			CleanUp(0,1);
			EndDialog(PasswordDialog_hWnd,0);
		}

		break;
	}
	return 0;
}

