
///////////////////////////////////////////////////////////////////////

extern int PackFiles(char *xTargetFile, char *Directory)
{
	static char File[20480];
	static int ReturnFlag;
	static OPENFILENAME ofn;

	PackingFiles = 1;

	ofn.lStructSize=sizeof(ofn);

//	  ofn.hwndOwner = 0;
	ofn.nFilterIndex = 1;
	ofn.lpstrFile = File;
	ofn.nMaxFile = sizeof(File);
	ofn.lpstrInitialDir = Directory;
	ofn.Flags = OFN_ALLOWMULTISELECT + OFN_EXPLORER + OFN_LONGNAMES + OFN_FILEMUSTEXIST ;
	ofn.lpstrTitle=TitleCaption;
	ReturnFlag = GetOpenFileName(&ofn);  // Open GetOpenFileName Dialog
	Get_NumberOfFiles(ofn.lpstrFile);

	if(ReturnFlag == 0) // No Files Selected
		return 0;

	if(Number_Of_Files == 0) // Only One File Selected
	{
		KillFlag=1;
		MessageBox(0, "You Must Select More Than One File." , TitleCaption, 0 + MB_ICONASTERISK);
		unlink(xTargetFile);
		return 0;
	}

	if(Number_Of_Files > 100) // Only One File Selected
	{
		KillFlag=1;
		MessageBox(0, "You Cannot Select  More Than 100 Files." , TitleCaption, 0 + MB_ICONASTERISK);
		unlink(xTargetFile);
		return 0;
	}

	if(WriteFiles(xTargetFile,ofn.nFileOffset,ofn.lpstrFile,ofn.lpstrFile))
	{
		return 1;
	}
	return 0;
}

///////////////////////////////////////////////////////////////////////

extern int WriteFiles(char *xTargetFile, short xPlaceHolder, char *FullFileString, char *Directory)
{
	static int LocalFileCount;
	static int ClearLoop;
	static int PlaceHolder;
	static short SentSize = 0;

	static long FileSize_Temp;

	static char Local_Result[1024];
	static char FullFilePath[1024];
	static char Local_ScanTemp[7];
	static char StatusTemp[257];

	static float Status_Number_Of_Files;
	static float Status_LocalFileCount;
	static float Status_Percent_Done;

	static FILE *LocalSource_File;
	static FILE *LocalTarget_File;

	Thread_Handle = CreateThread(NULL,0,Thread,(LPVOID)0,0,&Thread_ID);

	/* Open xTargetFile File */

	SetFileAttributes(xTargetFile,FILE_ATTRIBUTE_NORMAL);
	if((LocalTarget_File = fopen(xTargetFile,"wb")) == NULL)
	{
		if(LocalTarget_File)fclose(LocalTarget_File);
		unlink(xTargetFile);
		static char ErrorTemp[1024];
		sprintf(ErrorTemp,"Could Not Open %s For Write. Error 14.",xTargetFile);
		Error(ErrorTemp);
		return 0;
	}

	{//Print Number Of Files (Begin)
	if(Number_Of_Files < 1000)
		fprintf(LocalTarget_File,"0");
	if(Number_Of_Files < 100)
		fprintf(LocalTarget_File,"0");
	if(Number_Of_Files < 10)
		fprintf(LocalTarget_File,"0");
	fprintf(LocalTarget_File,"%d|",Number_Of_Files);
	}//Print Number Of File (End)


	{//Print File Contents (Begin)
	PlaceHolder = xPlaceHolder;
	LocalFileCount = 0;

	Status_Number_Of_Files = Number_Of_Files;

	while(LocalFileCount < Number_Of_Files)
	{
		LocalFileCount++;

		Status_LocalFileCount = LocalFileCount;
		Status_Percent_Done = (Status_LocalFileCount / Status_Number_Of_Files) *100;
		StatusValue = Status_Percent_Done;
		sprintf(StatusTemp,"Unpacking File %d of %d",LocalFileCount,Number_Of_Files);
		Status = StatusTemp;

		sprintf(StatusTemp,"Packing File %d of %d",LocalFileCount,Number_Of_Files);

		while(FullFileString[PlaceHolder] != '\0')
		{
			sprintf(Local_ScanTemp,"%c",FullFileString[PlaceHolder]);
			strcat(Local_Result,Local_ScanTemp);
			PlaceHolder++;
		}

		if(strlen(Directory) == 3)
		{
			sprintf(FullFilePath,"%s%s",Directory,Local_Result);
		}
		else
			{
				sprintf(FullFilePath,"%s\\%s",Directory,Local_Result);
			}

		SetFileAttributes(FullFilePath,FILE_ATTRIBUTE_NORMAL);

		{ // (Begin) Write File Size
		FileSize_Temp = FileSize(FullFilePath);

		if(FileSize_Temp == -1)
		{
			KillFlag = 1;
			if(LocalSource_File)fclose(LocalSource_File);
			if(LocalTarget_File)fclose(LocalTarget_File);
			unlink(xTargetFile);
			Error("Error Sizing File. Error 15.");
		}

		if(FileSize_Temp == -2)
		{
			KillFlag = 1;
			if(LocalSource_File)fclose(LocalSource_File);
			if(LocalTarget_File)fclose(LocalTarget_File);
			unlink(xTargetFile);
			Error("Error Sizing File. Error 16.");
		}

		if(FileSize_Temp > (1024 * 1024) * 2)
		{
			static char ErrorTemp[1024];
			KillFlag = 1;
			sprintf(ErrorTemp,"%s Is Too Big! \r\n Files Must Be Under 2 MegaBytes.",Local_Result);
			MessageBox(0, ErrorTemp , TitleCaption, 0 + MB_ICONASTERISK);
			if(LocalSource_File)fclose(LocalSource_File);
			if(LocalTarget_File)fclose(LocalTarget_File);
			unlink(xTargetFile);
			return 0;
		}

		if(FileSize_Temp <= 0)
		{
			static char ErrorTemp[1024];
			KillFlag=1;
			sprintf(ErrorTemp,"%s Contains No Data! \r\n Files Must Be Contain Some Data (At Least 1 Byte).",Local_Result);
			MessageBox(0, ErrorTemp , TitleCaption, 0 + MB_ICONASTERISK);
			if(LocalSource_File)fclose(LocalSource_File);
			if(LocalTarget_File)fclose(LocalTarget_File);
			unlink(xTargetFile);
			return 0;
		}

		if(FileSize_Temp < 10000000)
			fprintf(LocalTarget_File,"0");
		if(FileSize_Temp < 1000000)
			fprintf(LocalTarget_File,"0");
		if(FileSize_Temp < 100000)
			fprintf(LocalTarget_File,"0");
		if(FileSize_Temp < 10000)
			fprintf(LocalTarget_File,"0");
		if(FileSize_Temp < 1000)
			fprintf(LocalTarget_File,"0");
		if(FileSize_Temp < 100)
			fprintf(LocalTarget_File,"0");
		if(FileSize_Temp < 10)
			fprintf(LocalTarget_File,"0");
		if(FileSize_Temp < 1)
			fprintf(LocalTarget_File,"0");
		if(FileSize_Temp != 0)
			fprintf(LocalTarget_File,"%d/",FileSize_Temp);
		} // (End) Write File Size

		fprintf(LocalTarget_File,"%s/",Local_Result);

		if((LocalSource_File = fopen(FullFilePath,"rb")) == NULL)
		{
			static char ErrorTemp[1024];
			if(LocalSource_File)fclose(LocalSource_File);
			if(LocalTarget_File)fclose(LocalTarget_File);
			unlink(xTargetFile);
			sprintf(ErrorTemp,"Could Not Open %s For Read. Error 17.",Local_Result);
			Error(ErrorTemp);
			return 0;
		}

		do
		{

			Buffer[0] = '\0';
			SentSize = fread(Buffer,sizeof(char),BufferSize,LocalSource_File);
			fwrite(Buffer,sizeof(char),SentSize,LocalTarget_File);
		}	while(SentSize == BufferSize);
		if(LocalSource_File)fclose(LocalSource_File);


		ClearLoop = 0;
		while(ClearLoop < sizeof(Local_Result)) // Clear ( Local_Result )
		{
			Local_Result[ClearLoop] = '\0';
			ClearLoop++;
		}
		ClearLoop = 0;
		while(ClearLoop < sizeof(Local_ScanTemp)) // Clear ( Local_ScanTemp )
		{
			Local_ScanTemp[ClearLoop] = '\0';
			ClearLoop++;
		}

		PlaceHolder++;
		if(FullFileString[PlaceHolder] == '\0')break;
	}
	}//Print File Contents (End)

	if(LocalSource_File)fclose(LocalSource_File);
	if(LocalTarget_File)fclose(LocalTarget_File);

	return 1;
}

///////////////////////////////////////////////////////////////////////

