
//--------------------------------------------------------------------

#include "Headers/SelectFunc.H"


//--------------------------------------------------------------------

//////////////////////////////////////////////////////////////////////

extern void Error(char *Message)
{
	KillFlag = 1;
	MessageBox (GetActiveWindow(), Message ,TitleCaption,0 + MB_ICONHAND + MB_SYSTEMMODAL);
	CleanUp(1,1);
}

//////////////////////////////////////////////////////////////////////

extern int CleanUp(int Kill, int Delete)
{
	if(Working_File)fclose(Working_File);
	if(CypherTemp_File)fclose(CypherTemp_File);
	if(EncryptTemp_File)fclose(EncryptTemp_File);


	if(Delete)
	{
		unlink(EncryptTemp);
		unlink(PackBackupTemp);
	}

	if(Kill)
	{
		unlink(EncryptTemp);
		unlink(PackBackupTemp);
		exit(0);
	}

	return 0;
}

//////////////////////////////////////////////////////////////////////

extern int Encrypted(char *FileToCheck)
{
	static FILE * FileToCheck_File;

	if(FileToCheck_File)fclose(FileToCheck_File);

	SetFileAttributes(FileToCheck,FILE_ATTRIBUTE_NORMAL);
	if((FileToCheck_File = fopen(FileToCheck,"rb")) == NULL)
		Error("Could Not Open Source For Read. Error: 10.");

	static char Buffer[BufferSize*2];
	Buffer[0] = '\0';

	fread(Buffer,sizeof(char),10,FileToCheck_File);

	if(strcmp(Buffer,"Encrypted~") == 0)
	{
		if(FileToCheck_File)
			fclose(FileToCheck_File);
		End_Of_File = 0;
		return 1;
	}

	if(strcmp(Buffer,"128Packed~") == 0)
	{
		if(FileToCheck_File)
			fclose(FileToCheck_File);
		End_Of_File = 0;
		return 2;
	}

	if(FileToCheck_File)
		fclose(FileToCheck_File);
	return 3;
}

//////////////////////////////////////////////////////////////////////

extern int SetTempVariables()
{
	sprintf(EncryptTemp,"%s\\%s",GetTempDirectory(),"Encrypt.128G");
	sprintf(PackBackupTemp,"%s\\%s",GetTempDirectory(),"PackBackup.128G");
	if(!EncryptTemp)
		return 1;
	if(!PackBackupTemp)
		return 1;
	return 0;
}

//////////////////////////////////////////////////////////////////////

extern int CharInt(char *string2convert)
{
	int i, lenght_string;
	int power;
	int tmp_number;
	char tmp_char;
	if (!string2convert)
	{
		string2convert = "0";
		Error("Character To Interger Conversion Error. Error: 11.");
		return -1;
	}
	lenght_string = strlen(string2convert);
	for(i = 0; i < (lenght_string / 2); i++)
	{
		tmp_char = string2convert[i];
		string2convert[i] = string2convert[lenght_string - 1 - i];
		string2convert[lenght_string - 1 - i] = tmp_char;
	}
	power = 1;
	i = 0;
	tmp_number = 0;
	while (string2convert[i] != '\0')
	{
		tmp_number += (string2convert[i] - '0') * power;
		power *= 10;
		i++;
	}
	return tmp_number;
}

/////////////////////////////////////////////////////////////////////

extern char *GetTempDirectory(void)
{
	static char StrFunction [64][257];
	static int StrCnt;
	static char T [257];
	GetTempPath (256,T);
	if (++StrCnt==64) StrCnt = 0;
	sprintf(StrFunction[StrCnt],"%s",T);
	return StrFunction[StrCnt];
}

//////////////////////////////////////////////////////////////////////

extern void SetText (HWND hDlg, char *Txt)
{
	SendMessage(hDlg,(UINT)WM_SETTEXT,(WPARAM)0,(LPARAM)Txt);
}

/////////////////////////////////////////////////////////////////////

extern char *GetText (HWND hDlg)
{
	static short LocalLoop;
	static int StrCnt;
	static int T;
	static char xBuffer[2048];
	LPSTR StrFunc [16];
	LocalLoop = 0;
	StrCnt = 0;
	while(LocalLoop < 16)
	{
		StrFunc[LocalLoop] = '\0';
		LocalLoop++;
	}
	if (++StrCnt==16) StrCnt = 0;
	if (StrFunc[StrCnt]) free (StrFunc[StrCnt]);
	StrFunc[StrCnt] = (char*) malloc (2048);
	memset (StrFunc[StrCnt],0,2048);
	T=GetWindowTextLength(hDlg);
	GetWindowText(hDlg,xBuffer,T+1);
	sprintf(StrFunc[StrCnt],"%s",xBuffer);
	return StrFunc[StrCnt];
}
/////////////////////////////////////////////////////////////////////

extern void CenterWindow (HWND hWnd)
{
	static	RECT  wRect;
	static	DWORD  x;
	static	DWORD  y;
	GetWindowRect(hWnd,&wRect);
	x=(GetSystemMetrics(SM_CXSCREEN)-(wRect.right-wRect.left))/2;
	y=(GetSystemMetrics(SM_CYSCREEN)-(wRect.bottom-wRect.top+GetSystemMetrics(SM_CYCAPTION)))/2;
	SetWindowPos(hWnd,NULL,x,y,0,0,SWP_NOSIZE|SWP_NOZORDER);
}

/////////////////////////////////////////////////////////////////////

extern short FileEmpty(char *File2Size)
{
	FILE *fp;
	static short size;
	size = 0;

	SetFileAttributes(File2Size,FILE_ATTRIBUTE_NORMAL);
	if((fp = fopen(File2Size,"r+b")) == NULL)
	{
		Error("Could Not Open Source For Read. Error 12.");
		return 0;
	}

	while(!feof(fp))
	{
		fgetc(fp);
		if(!feof(fp))
		{
			size++;
		}

		if(size > 0)
		{
			if(fp)fclose(fp);
			return 0;
		}

		if(ferror(fp))
		{
			Error("Error Sizing File. Error 13.");
			return 0;
		}
	}

	if(fp)fclose(fp);
	if(size == 0)return 1;
	return 0;
}

/////////////////////////////////////////////////////////////////////

extern int EncryptProcess(void)
{
	static short ENCMethod;
	ENCMethod = 0;
	ENCMethod = Encrypted(F);
	CleanUp(0,1);


	if(ENCMethod == 1) // Encrypted
	{
		KillFlag=1;
		MessageBox (0, "The File You Are Trying To Encrypt Is Already Encrypted!" ,TitleCaption, 0 + MB_ICONASTERISK + MB_TASKMODAL);
		CleanUp(0,1);
		return(0);
	}

	if(ENCMethod == 2) // Packed
	{
		KillFlag=1;
		MessageBox (0, "The File You Are Trying To Encrypt Is Already Packed!" ,TitleCaption, 0 + MB_ICONASTERISK + MB_TASKMODAL);
		CleanUp(0,1);
		return(0);
	}

	if(ENCMethod == 3) // NOT Encrypted
	{
		Status = "Calculating File Size...";
		SourceFileSize = FileSize(F);
		Status = "Ciphering...";
		/* EnCode(Source,Target,Password); */
		if(EnCode(F,EncryptTemp,GetText(PasswordEdit_hWnd)))
		{
			Status = "Calculating File Size...";
			SourceFileSize = FileSize(EncryptTemp);
			Status = "Encoding...";
			/* IncodeMain(Source,Target); */
			if(IncodeMain(EncryptTemp,F) == 0)
			{
				Status = "Data Successfully Encrypted!";
			}
		}
		CleanUp(0,1);
		return(0);
	}

	CleanUp(0,1);
	return(0);
}

/////////////////////////////////////////////////////////////////////

extern int DecryptProcess(void)
{
	static short ENCMethod;
	ENCMethod = 0;
	ENCMethod = Encrypted(F);
	CleanUp(0,1);

	if(ENCMethod == 1) // Encrypted
	{
		Status = "Calculating File Size...";
		SourceFileSize = FileSize(F);
		Status = "Decoding...";
		if(DecodeMain(F,EncryptTemp) == 0)
		{
			Status = "Calculating File Size...";
			SourceFileSize = FileSize(EncryptTemp);
			Status = "Deciphering...";
			if(DeCode(EncryptTemp,F,GetText(PasswordEdit_hWnd)) == 0)
			{
				Status = "Data Successfully Decrypted!";
			}
		}
		CleanUp(0,1);
		return(0);
	}

	if(ENCMethod == 2) //  Packed
	{
		static char xPath[257];
		static char xDrive[11];

		xPath[0] = '\0';
		xDrive[0] = '\0';

		static char SourceFilePath[257];
		/* Split Drive And Path Of SourceFileName And Set Then To (SourceFilePath) */

		_splitpath(F,xDrive,xPath,NULL,NULL);
		sprintf(SourceFilePath,"%s%s",xDrive,xPath);
		UnPackingFiles = 1;

		Status = "Calculating File Size...";
		SourceFileSize = FileSize(F);
		Status = "Decoding...";
		if(DecodeMain(F,EncryptTemp) == 0)
		{
			Status = "Calculating File Size...";
			SourceFileSize = FileSize(EncryptTemp);
			Status = "Deciphering...";
			if(DeCode(EncryptTemp,PackBackupTemp,GetText(PasswordEdit_hWnd)) == 0)
			{
				Status = "UnPacking Files...";
				if(UnPackFiles(PackBackupTemp,SourceFilePath))
				{
					Status = "Files Successfully UnPacked!";
					CleanUp(0,1);
				}
			}
		}
		CleanUp(0,1);
		return(0);
	}

	if(ENCMethod == 3) // NOT Encrypted
	{
		KillFlag=1;
		MessageBox (0, "The File You Are Trying To Decrypt Is Not Encrypted!" , TitleCaption, 0 + MB_ICONASTERISK);
		CleanUp(0,1);
		return(0);
	}

	CleanUp(0,1);
	return(0);
}

/////////////////////////////////////////////////////////////////////

extern int ProcessInput(char *xInput)
{
	static short ENCMethod;
	ENCMethod = 0;
	//	  ENCMethod = Encrypted(F);
	/* ENCMethod ( 1 = Encrypted , 2 = Packed , 3 = NOT Encrypted) */

	if(strlen(xInput) > 0) // If Any Program Input Params
	{
		static char Extention[257];
		static char xDrive[7];
		static char xPath[257];
		static char Directory[257];

		SetFileAttributes(xInput,FILE_ATTRIBUTE_NORMAL);

		Extention[0] = '\0';
		_splitpath(xInput,xDrive,xPath,NULL,Extention);

		if(FileEmpty(xInput) && (strcmp(Extention,".128") == 0) )
		{
			sprintf(Directory,"%s%s",xDrive,xPath);

			if(PackFiles(xInput,Directory))
			{
				sprintf(F,"%s",xInput);
				MethodFlag = PACFlag;
				Encrypt = 1;
				Decrypt = 0;
				DialogBox(hInstance,MAKEINTRESOURCE(100),0,PasswordDialog);
			}

			CleanUp(0,1);
			return(0);
		}

		MethodFlag = ENCFlag;
		sprintf(F,"%s",xInput);
		ENCMethod = Encrypted(F);

		if(ENCMethod == 1) // Encrypted
		{
			Encrypt = 0;
			Decrypt = 1;
			ENCMethod = 0;
			DialogBox(hInstance,MAKEINTRESOURCE(100),0,PasswordDialog);
			ENCMethod = 0;
			CleanUp(0,1);
			return(0);

		}

		if(ENCMethod == 2) //  Packed
		{
			Encrypt = 0;
			Decrypt = 1;
			ENCMethod = 0;
			DialogBox(hInstance,MAKEINTRESOURCE(100),0,PasswordDialog);
			ENCMethod = 0;
			CleanUp(0,1);
			return(0);

		}

		if(ENCMethod == 3) // NOT Encrypted
		{
			Encrypt = 1;
			Decrypt = 0;
			ENCMethod = 0;
			DialogBox(hInstance,MAKEINTRESOURCE(100),0,PasswordDialog);
			ENCMethod = 0;
			CleanUp(0,1);
			return(0);
		}
	}

	CleanUp(0,1);
	return 1;
}

/////////////////////////////////////////////////////////////////////

extern DWORD WINAPI Thread(LPVOID data)
{
	DialogBox(hInstance,MAKEINTRESOURCE(200),0,StatusDialog);
	return ((DWORD)data);
}

/////////////////////////////////////////////////////////////////////

extern char *CipherKey(char InputPassword[71])
{
	static int LocalLoop;
	static char xCodedKey[27];
	LocalLoop = 0;

	while(LocalLoop < strlen(InputPassword))
	{
		xCodedKey[LocalLoop] = InputPassword[LocalLoop] + 128;
		LocalLoop++;
	}

	return xCodedKey;
}

/////////////////////////////////////////////////////////////////////

